import { ScenarioProfile } from './profile';
import { ProcessedScenario } from './process';
import { ScenarioAnalysis } from './analyze';
export declare type Scenario = {
    scenario: string;
    baseline?: string;
};
export interface Scenarios {
    [scenarioName: string]: Scenario;
}
export declare type ScenarioConfig = {
    outDir?: string;
    tempDir?: string;
};
export interface CookResult {
    profile: ScenarioProfile;
    processed: ProcessedScenario;
    analysis?: ScenarioAnalysis;
}
export interface CookResults {
    [scenarioName: string]: CookResult;
}
/**
 *
 * @param {Scenarios} scenarios Scenarios under test.
 * @param {ScenarioConfig} userConfig Optional user configuration. Paths not provided default to working directory.
 */
export declare function cook(scenarios: Scenarios, userConfig?: ScenarioConfig): Promise<CookResults>;
declare const _default: {
    cook: typeof cook;
};
export default _default;
//# sourceMappingURL=flamegrill.d.ts.map